--
-- sieve.as: A prime number sieve to count primes <= n.
--
#include "axiom.as"
#pile
import from Boolean, MachineInteger, NonNegativeInteger

sieve(n: NonNegativeInteger): MachineInteger  ==
        isprime: PrimitiveArray Boolean := new(n+1, true)

        modr ==> positiveRemainder
        x: Integer := 10
        y: Integer := 12
        z7: Integer := 5
        nn: Integer := 3
        iter: Integer :=0
        maxIter: Integer := 1
        while iter < maxIter repeat
          x := modr (x*x + z7, nn)
          y := modr (y*y + z7, nn)
          iter := iter +1

        np := 0$MachineInteger
        for p in 2..n | isprime (p::Integer) repeat
                np := np + 1
                for i in 2*p..n by p::Integer repeat isprime(i::Integer) := false
        np
